 
namespace eval NasComposite {
 
    variable edit_data {
       R0lGODlhGAAYAOMAAAICBK2tmo2NgOXlztXVvzY2MlxcWfLy2///////////
       /////////////////////yH5BAEKAAgALAAAAAAYABgAAAR/EMlJq704awu2
       BkDQeRVIDERBTibhnuPWuugwiLLw7vagfj4XoGcDHGIX46FAMBWHzcxwKQD1
       QIej9GAQDozgrDYJoA3PRzGO8/p+08pstERrFrPxw7x0HaT/R0gUZUR+Ygdf
       GwY2h2JVHlOGWYkreSiCMgRyBpiQep2VoCujEQA7
    }
    variable edit [image create photo -data [set edit_data]]


    
    variable delete_data {
       R0lGODlhDwAPAKEAAP8AAICAgAAAAP///yH+Dk1hZGUgd2l0aCBHSU1QACH5
       BAEKAAMALAAAAAAPAA8AAAIxnI+AAxDbXJIstnesvlOLj2XWJyzVWEKNYIUi
       wEbu+RnyW4vhmk4p3IOkcqYBsWgqAAA7
    }
    variable delete [image create photo -data [set delete_data]]

variable e1 ""
variable e2 ""
variable nu12 ""
variable g12 ""
variable g23 ""
variable g13 ""
variable dens ""
variable t ""
variable ang ""
variable title "mat 1"
variable matlist ""
variable lamlist ""
variable index -1
variable lamindex -1
variable currenttitle "mat 1"
variable cbdatamat
variable matname ""
variable failure
variable z0 ""
variable stressbon ""
variable ID 1
variable badd
variable bmodify
variable bnew
variable bcancel
variable lamadd
variable lammodify
variable lamcancel
variable lamclear
variable useangle 1 
variable numlayers
variable can
variable table
variable lamtable
variable gidmatnum
variable values
variable edatae1
}
##############################################################
#Comunitaction with GiD                             #
##############################################################
proc NasComposite::ComunicateWithGiD { op args } {
    switch $op {
	"INIT" {
	    set PARENT [lindex $args 0]
	    upvar [lindex $args 1] ROW
	    set GDN [lindex $args 2]
	      set STRUCT [lindex $args 3]
	    set f [frame $PARENT.f]
	    NasComposite::InitWindow $f 
	    grid $f -row $ROW -column 0 -sticky nsew -columnspan 2 -pady 3 -padx 2
	    grid columnconf $f 0 -weight 1
	    grid rowconf $f 0 -weight 1
	    grid rowconf $PARENT $ROW -weight 1
	    grid columnconf $PARENT 0 -weight 1
	    upvar \#0 $GDN GidData
	     if { $GidData($STRUCT,VALUE,4) != 0 } {
		NasComposite::getvalues $GidData($STRUCT,VALUE,3) \
		        $GidData($STRUCT,VALUE,4) $GidData($STRUCT,VALUE,5)
	     }
	     return ""
	 }
	 "SYNC" {
	     set GDN [lindex $args 0]
	     set STRUCT [lindex $args 1]
	     set values [ NasComposite::dump ]
	     set names [ NasComposite::infonames ]
	     DWLocalSetValue $GDN $STRUCT "laminate_properties" $values
	     DWLocalSetValue $GDN $STRUCT "win_info" $names
	     DWLocalSetValue $GDN $STRUCT "numero_de_capas" [lindex $values 0]
	    if { $values !=0 } { 
		DWLocalSetValue $GDN $STRUCT "laminate" [list $NasComposite::z0 $NasComposite::stressbon \
		        $NasComposite::failure]
		DWLocalSetValue $GDN $STRUCT "nastran" [NasComposite::nastran]
	    }
	     return ""
	}
    }
}
proc NasComposite::InitWindow { top }  {
    variable cbdatamat
    variable badd
    variable bmodify
    variable bnew
    variable bcancel
    variable lamadd
    variable lammodify
    variable lamcancel
    variable lamclear
    variable can
    variable matlist
    variable table
    variable lamtable 
    variable values ""
    variable edatae1
    ##############################################################
    #creating the notebook to organize the information           #
    ##############################################################
    set nb [NoteBook $top.notebook -height 300 -width 550 ]
    set page1 [$nb insert end page1 -text Laminate]
    set page2 [$nb insert end page2 -text Materials]
    $nb raise page1
    grid $nb -sticky nsew
    grid columnconf $page1  0 -weight 1
    grid rowconf $page1 0 -weight 1
    grid columnconf $page2  0 -weight 1
    grid rowconf $page2 0 -weight 1
    ##############################################################
    #creating the page for materials information "Materials"     #
    ##############################################################
    set table ""
    set pw [PanedWindow $page2.pw -side left ]
    set pane1 [$pw add -weight 0]


    set title1 [TitleFrame $pane1.data -relief groove -bd 2 -ipad 6 \
	    -text "Data Entry" -side left]
    set f1 [$title1 getframe]
    set ldatatitle [label $f1.ldatatitle -text Title -justify left ]
    set edatatitle [entry $f1.edatatitle -textvariable NasComposite::title -width 8 \
	    -justify left  -bd 2 -relief sunken] 
    set ldatae1 [label $f1.ldatae1 -text E1 -justify left ]
    set edatae1 [entry $f1.edatae1 -textvariable NasComposite::e1 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]
    set ldatae2 [label $f1.ldatae2 -text E2 -justify left]
    set edatae2 [entry $f1.edatae2 -textvariable NasComposite::e2 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]
    set ldatanu12 [label $f1.ldatanu12 -text nu12 -justify left ]
    set edatanu12 [entry $f1.edatanu12 -textvariable NasComposite::nu12 -width 12 \
	    -justify left -width 8 -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]
    set ldatag12 [label $f1.ldatag12 -text G12 -justify left ]
    set edatag12 [entry $f1.edatag12 -textvariable NasComposite::g12 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]
    set ldatag13 [label $f1.ldatag13 -text G13 -justify left ]
    set edatag13 [entry $f1.edatag13 -textvariable NasComposite::g13 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]
    set ldatag23 [label $f1.ldatag23 -text G23 -justify left ]
    set edatag23 [entry $f1.edatag23 -textvariable NasComposite::g23 -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]

    set ldatadens [label $f1.ldatadens -text "Mass Density" -justify left ]
    set edatadens [entry $f1.edatadens -textvariable NasComposite::dens -width 12 \
	    -justify left -bd 2 -relief sunken -validate focusout \
	    -vcmd {string is double %P} -invcmd bell]  
    grid $pw  -sticky nsew 
    grid rowconf $pw 1 -weight 1
    grid columnconf $pw 0 -weight 1
    grid columnconf $pane1 0 -weight 1
    grid rowconf $pane1 0 -weight 1
    
    grid $title1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
    grid rowconf $f1 4 -weight 1
    grid $ldatatitle -column 0 -row 0
    grid $edatatitle -column 1 -row 0 -columnspan 5 -sticky nswe
    grid $ldatae1 -column 0 -row 1
    grid $edatae1 -column 1 -row 1 -sticky nswe
    grid $ldatae2 -column 2 -row 1
    grid $edatae2 -column 3 -row 1 -sticky nswe
    grid $ldatanu12 -column 4 -row 1 -sticky se
    grid $edatanu12 -column 5 -row 1 -sticky nswe
    grid $ldatag12 -column 0 -row 2
    grid $edatag12 -column 1 -row 2 -sticky nswe
    grid $ldatag13 -column 2 -row 2
    grid $edatag13 -column 3 -row 2 -sticky nswe
    grid $ldatag23 -column 4 -row 2
    grid $edatag23 -column 5 -row 2 -sticky nswe
    grid $ldatadens -column 0 -row 3 
    grid $edatadens -column 1 -row 3 -sticky nswe
	
    set pane2 [$pw add -weight 1]
    set title2 [TitleFrame $pane2.table -relief groove -bd 2 -text "Materials List" \
	    -side left ]
    set f2 [$title2 getframe]
    set sw [ScrolledWindow $f2.scroll -scrollbar both ]
    set table [tablelist::tablelist $sw.table \
	    -columns {0 "Title" 0 "E1" 0 "E2" 0 "nu12" 0 "G12" 0 "G23" 0 "G13" 0 "Mass Den."} \
	    -height 3 -width 80 -stretch all -background white -labelbg lightyellow \
	    -listvariable NasComposite::matlist -selectmode extended]
    $sw setwidget $table
    
    set bbox [ButtonBox $f2.bbox1 -spacing 0 -padx 1 -pady 1 -homogeneous 0 ]
    $bbox add -image $NasComposite::edit -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Edit material" -command "NasComposite::edit $table"
    $bbox add -image $NasComposite::delete -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Delete material" -command "NasComposite::delete $table $edatatitle"
    
    set badd [button $f1.badd -text Add  -width 10 -underline 0 \
	    -command "NasComposite::add $table $edatae1 $edatatitle" ]
    set bmodify [button $f1.modify -text Modify  -width 10 -underline 0 \
	    -command "NasComposite::add $table $edatae1 $edatatitle" ]
    set bcancel [button $f1.cancel -text Cancel  -width 10 -underline 0 \
	    -command "NasComposite::cancel $table $edatae1"]
     set bnew [button $f1.bnew -text New  -width 10 -underline 0 \
	    -command "set NasComposite::index -1 ; NasComposite::add $table $edatae1 $edatatitle" ]
    
    grid $badd -column 0 -row 4 -columnspan 3 -pady 6 -sticky nw
    grid $bmodify -column 0 -row 4 -columnspan 3 -pady 6 -sticky nw
    grid $bnew -column 3 -row 4 -columnspan 3 -pady 6 -sticky nw
    grid $bcancel -column 6 -row 4 -columnspan 3 -pady 6 -sticky nw
    grid remove $bmodify
    grid remove $bnew
    grid remove $bcancel
    bind $top <Alt-KeyPress-a> "tkButtonInvoke $badd"                
    bind $top <Alt-KeyPress-m> "tkButtonInvoke $bmodify"
    bind $top <Alt-KeyPress-c> "tkButtonInvoke $bcancel"
    bind $top <Alt-KeyPress-c> "tkButtonInvoke $bcancel"
    grid columnconf $pane2  0 -weight 1
    grid rowconf $pane2 0 -weight 1
    grid columnconf $pane1  0 -weight 1
    
    grid $title2 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew 
    grid columnconf $f2  0 -weight 1
    grid rowconf $f2 0 -weight 1


    grid $sw -column 0 -row 0 -sticky nsew
    grid $bbox -column 0 -row 1 -sticky nw
    $nb compute_size
    bind $badd <ButtonRelease> {
		   set NasComposite::values "8 $NasComposite::e1 $NasComposite::e2 $NasComposite::g13 $NasComposite::g12 $NasComposite::g23 \
		$NasComposite::nu12 $NasComposite::dens"
	NasComposite::errorcntrl $NasComposite::values $NasComposite::edatae1
	}
    bind [$table bodypath] <Double-ButtonPress-1> { NasComposite:::edit $NasComposite::table }
    ##############################################################
    #creating the page for laminate information "Laminate"       #
    ##############################################################
    
    set pw [PanedWindow $page1.pw -side top ]
    set pane1 [$pw add -weight 1]

    set title1 [TitleFrame $pane1.data -relief groove -bd 2 \
	    -text "Data Entry" -side left]
    set f1 [$title1 getframe]
    set ldatamat [label $f1.ldatamat -text "Material" -justify left ]
    set cbdatamat [ComboBox $f1.cb -textvariable NasComposite::matname  \
	    -values "" -editable 0]
    set ldataspin [label $f1.ldataspin -text "Number of layers:" -justify left]
    set spin [SpinBox $f1.spdata -textvariable NasComposite::numlayers \
	    -range "1 1000 1" -width 2 -takefocus 1]
    set ldatat [label $f1.ldatat -text "Thickness" -justify left ]
    set edatat [entry $f1.edatat -textvariable NasComposite::t -width 3 \
	    -justify left -bd 2 -relief sunken -validate key \
	    -vcmd {string is double %P} -invcmd bell]
    set edataang [entry $f1.edataang -textvariable NasComposite::ang -width 6 \
	    -justify left -bd 2 -relief sunken -state normal -bg white]
    set bgcolor [$f1 cget -background]
    set check [checkbutton $f1.chdata -variable NasComposite::useangle \
	    -takefocus 0 -text "Fiber Angle"]
    set title11 [TitleFrame $pane1.data1 -relief groove -bd 2 \
	    -text "Laminate Properties" -side left]
    set f11 [$title11 getframe]
    set NasComposite::failure None
    set lfailure [label $f11.lfailure -text "Failure Theory" -justify left]
    set cbfailure [ComboBox $f11.cbfailure -textvariable NasComposite::failure  \
	    -values [list "None" "Hill" "Hoffman" "Tsai-Wu" "Stress" "Strain"] \
	    -editable 0]
    set lz0 [Label $f11.lz0 -text "Distance Bottom" -helptext "Distance to the reference plane\n\
	    to the bottom surface" -justify left]
    set ez0 [entry $f11.ez0 -textvariable NasComposite::z0 -width 6 \
	    -justify left -bd 2 -relief sunken -validate key \
	    -vcmd {string is double %P} -invcmd bell] 
    set lstressbon [Label $f11.lstressbon -text "Allowable Stress" \
	    -helptext "Allowable shear stress \n\
	    of the bonding material" -justify left]
    set estressbon [entry $f11.estressbon -textvariable NasComposite::stressbon -width 6 \
	    -justify left -bd 2 -relief sunken -validate key \
	    -vcmd {string is double %P} -invcmd bell] 
    NasComposite::update $edataang $bgcolor
    set command "NasComposite::update [list $edataang $bgcolor];#"
    trace variable NasComposite::useangle w $command
    bind $f1.chdata <Destroy> [list trace vdelete NasComposite::useangle w $command]
    
    grid $pw  -sticky nsew 
    grid columnconf $pw  1 -weight 1
    grid rowconf $pw 0 -weight 1
    grid columnconf $pane1  0 -weight 1
    grid rowconf $pane1 2 -weight 1
    grid $title1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
    grid rowconf $f1 4 -weight 1
    grid columnconf $f1  3 -weight 1
    grid $ldatamat -column 0 -row 0 -sticky nw
    grid $cbdatamat -column 1 -row 0 -columnspan 3 -sticky nwse
    grid $ldataspin -column 0 -row 1 -sticky nw
    grid $spin -column 1 -row 1 -sticky nswe
    grid $ldatat -column 2 -row 1 -sticky nw
    grid $edatat -column 3 -row 1 -sticky nswe
    grid $check -column 0 -row 2 -sticky nw
    grid $edataang -column 1 -row 2 -sticky nw
    grid $title11 -column 0 -row 1 -sticky nsew -padx 2 -pady 2
    grid $lfailure -column 0 -row 0 -sticky nw
    grid $cbfailure -column 1 -row 0 -sticky nsew
    grid $lz0 -column 0 -row 1 -sticky nw 
    grid $ez0 -column 1 -row 1 -sticky nsew 
    grid $lstressbon -column 0 -row 2 -sticky nw 
    grid $estressbon -column 1 -row 2 -sticky nsew 

    set pane2 [$pw add -weight 1]
    set title2 [TitleFrame $pane2.table -relief groove -bd 2 -text "Laminate Composition" \
	    -side left ]
    set f2 [$title2 getframe]
    set sw [ScrolledWindow $f2.scroll -scrollbar both ]
    set lamtable [tablelist::tablelist $sw.table \
	    -columns { 0 "Material" 0 "Angle" 0 "Thick" 0 "Layers"} \
	    -height 40 -width 30 -stretch all -background white -labelbg lightyellow \
	    -listvariable NasComposite::lamlist -selectmode extended]
    $sw setwidget $lamtable
    
    set bbox [ButtonBox $f2.bbox1 -spacing 0 -padx 1 -pady 1 -homogeneous 0 ]
    $bbox add -image $NasComposite::edit -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Edit layer" -command "NasComposite::lamedit $lamtable"
    $bbox add -image $NasComposite::delete -width 24 \
	    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Delete layer" -command "NasComposite::lamdelete $lamtable $cbdatamat"
    
    set lamadd [button $f1.badd -text Add  -underline 1 -width 10 \
	    -command "NasComposite::lamadd $lamtable $cbdatamat"]
    set lamclear [button $f1.bclear -text "Clear All" -width 10 -underline 2 \
	    -command "NasComposite::lamclear $lamtable"]
    set lammodify [button $f1.bmodify -text Modify  -width 10 -underline 1 \
	    -command "NasComposite::lamadd $lamtable $cbdatamat"]
    set lamcancel [button $f1.bcancel -text Cancel  -width 10 -underline 2 \
	    -command "NasComposite::lamcancel $lamtable $cbdatamat"]
    bind $lamadd <ButtonRelease> {
	if { $NasComposite::matname == "" } {
	    WarnWin "Select a material"
	    catch { vwait $NasComposite::matname }
	}
	if { $NasComposite::useangle == 0 } { 
	    set NasComposite::values "2 $NasComposite::t " 
	    NasComposite::errorcntrl $NasComposite::values $NasComposite::can
	} else {
	    set NasComposite::values "3 $NasComposite::t  $NasComposite::ang" 
	    NasComposite::errorcntrl $NasComposite::values $NasComposite::can
	}
    }   
    grid $lamadd -column 0 -row 3 -padx 2 -pady 6
    grid $lamclear -column 2 -row 3 -columnspan 2 -pady 6 -sticky nw
    grid $lammodify -column 0 -row 3 -columnspan 2 -pady 6 -sticky nw
    grid $lamcancel -column 2 -row 3 -columnspan 2 -pady 6 -sticky nw
    grid remove $lammodify
    grid remove $lamcancel
    bind $top <Alt-KeyPress-d> "tkButtonInvoke $lamadd"                
    bind $top <Alt-KeyPress-o> "tkButtonInvoke $lammodify"
    bind $top <Alt-KeyPress-n> "tkButtonInvoke $lamcancel"
    bind $top <Alt-KeyPress-e> "tkButtonInvoke $lamclear"  
    bind [$lamtable bodypath] <Double-ButtonPress-1> { NasComposite:::lamedit $NasComposite:::lamtable }
    bind [$lamtable bodypath] <ButtonPress-3> "NasComposite::popupmenu $lamtable %X %Y"         
    
    #bind $lamtable <Double-ButtonPress-1> "[list NasComposite:::lamedit $lamtable]"
    bind [$lamtable bodypath] <Double-ButtonPress-1> { NasComposite:::lamedit $NasComposite:::lamtable }
    grid columnconf $pane2  0 -weight 1
    grid rowconf $pane2 0 -weight 1
    grid columnconf $pane2  0 -weight 1
    
    grid $title2 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew 
    grid columnconf $f2  0 -weight 1
    grid rowconf $f2 0 -weight 1


    grid $sw -column 0 -row 0 -sticky nsew
    grid $bbox -column 0 -row 1 -sticky nw
    ##############################################################
    #creating canvas                                             #
    ##############################################################
    set title3 [TitleFrame $pane1.canvas -relief groove -bd 2 -text "Visual Description" \
	    -side left ]
    set f3 [$title3 getframe]
    set can [canvas $f3.can -relief flat -bd 1 -width 300 -height 100 -bg white \
	    -highlightbackground black]
    grid $title3 -column 0 -row 2 -sticky nsew
    grid columnconf $f3 0 -weight 1
    grid rowconf $f3 0 -weight 1
    grid $can -column 0 -row 0 -sticky nsew
    bind $can <Configure> "NasComposite::refresh $can"
}                
##############################################################
#dump result into tablelist for materials                    #
##############################################################
proc NasComposite::add { table entry entrytitle} {
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13   
 variable dens 
 variable ID         
 variable title 
 variable index                   
 variable currenttitle   
 variable matlist   
 variable cbdatamat   
    
    set e1 [expr double($e1)]
    set e2 [expr double($e2)]
    set nu12 [expr double($nu12)]
    set g12 [expr double($g12)]
    set g13 [expr double($g13)]
    set g23 [expr double($g23)] 
		    
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    } 
    foreach name $matnames {
	if { $title == $name }  {
	    if { $index == -1 } {
		WarnWin "Another Material with this name already exists.\nPlease select a different name" $table 
		focus $entrytitle
		$entrytitle selection range 0 end 
		catch { grid remove $NasComposite::bmodify}
		return
	    }
	}
    }
    if { $index == -1 } {
	$table insert end "[list $title [format %8.3g $e1] \
	    [format %8.3g $e2] [format %#4.3f $nu12] [format %8.3g $g12] \
	    [format %8.3g $g23] [format %8.3g $g13] [format %#8.3g $dens]]"
	$table see end
	incr ID
	set title "mat $ID"
	set e1 ""        
	set e2 ""        
	set nu12 ""        
	set g12 ""        
	set g13 ""        
	set g23 ""
	set dens ""
	set currenttitle $title
	catch {
	    grid $NasComposite::badd
	    grid remove $NasComposite::bmodify
	    grid remove $NasComposite::bnew
	    grid remove $NasComposite::bcancel 
	}
    } else {
	$table delete $index 
	$table insert $index "[list $title [format %8.3g $e1] \
	    [format %8.3g $e2] [format %4.3f $nu12] [format %8.3g $g12] \
	    [format %8.3g $g23] [format %8.3g $g13] [format %#8.3g $dens]]"
	$table see $index
	set title $currenttitle
	set e1 ""        
	set e2 ""        
	set nu12 ""        
	set g12 ""        
	set g13 ""        
	set g23 ""
	set dens ""
	set index -1
	catch {
	    grid $NasComposite::badd
	    grid remove $NasComposite::bmodify
	    grid remove $NasComposite::bnew
	    grid remove $NasComposite::bcancel
	} 
    }
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    focus $entry
}                
##############################################################
#     Edit row  intro tablelist of materials               #
##############################################################
proc NasComposite::edit { table } {
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13   
 variable dens 
 variable title        
 variable index
 variable currenttitle 
    
    set currenttitle "$title" 
    set index [$table curselection]
    if { $index != "" } {
	set entry [$table get $index]
	set title [lindex $entry 0]
	set e1 [lindex $entry 1]
	set e2 [lindex $entry 2]
	set nu12 [lindex $entry 3]
	set g12 [lindex $entry 4]
	set g13 [lindex $entry 6]
	set g23 [lindex $entry 5]
	set dens [lindex $entry 7]
	catch {
	    grid $NasComposite::bmodify
	    grid $NasComposite::bcancel
	    grid $NasComposite::bnew
	    grid remove $NasComposite::badd
	}
    }
} 
##############################################################
#     Cancel edit process intro tablelist of materials       #
##############################################################
proc NasComposite::cancel { table entry } {
 variable e1         
 variable e2         
 variable nu12         
 variable g12         
 variable g23         
 variable g13
 variable dens
 variable title        
 variable index
 variable currenttitle
    $table see end
    set title $currenttitle
    set e1 ""        
    set e2 ""        
    set nu12 ""        
    set g12 ""        
    set g13 ""        
    set g23 ""
    set dens ""
    set index -1
    catch {
	grid $NasComposite::badd
	grid remove $NasComposite::bmodify
	grid remove $NasComposite::bnew
	grid remove $NasComposite::bcancel     
    }
    focus $entry
}
##############################################################
#   Delete  a row  intro tablelist of materials              #
##############################################################
proc NasComposite::delete { table widget} {
    variable can
    variable cbdatamat
    variable matlist
    variable lamlist
    set entry [$table curselection]
    foreach index $entry {
	set currentmat [lindex [$table get $index] 0]
	foreach lam $lamlist {
	    if { $currentmat == [lindex $lam 0] } {
		WarnWin "This material ($currentmat) is used in laminate sequence\n\
		    Are you sure you want to delete it?"
	    }
	}
    }
    if { $entry != "" } {
	$table delete [lindex $entry 0] [lindex $entry end]
	$table see [lindex $entry 0]
    }
      
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    eval [NasComposite::refresh $can ]
    focus $widget
}
##############################################################
#           Delete a row intro tablelist of laminate         #
##############################################################
proc NasComposite::lamdelete { table widget} {
    variable can
    variable cbdatamat
    variable matlist
    set entry [$table curselection]
    if { $entry != "" } {
	$table delete [lindex $entry 0] [lindex $entry end]
	$table see [lindex $entry 0]
    }   
    set matnames ""
    set ipos1 0
    while { [lindex $matlist $ipos1] != "" } {
	set aux [lindex $matlist $ipos1]
	lappend matnames [lindex $aux 0]
	set ipos1 [ expr $ipos1+1 ]
    }
    $cbdatamat configure -values $matnames
    eval [NasComposite::refresh $can ]
    focus $widget
}
##############################################################
#         Dump result intro tablelist of laminate            #
##############################################################
proc NasComposite::lamadd { table entry } {
 variable t         
 variable ang         
 variable matname         
 variable numlayers  
 variable useangle
 variable lamindex
 variable can   
    if { $lamindex == -1 } {
	if { $useangle == 1 } {
	    set t [expr double($t)]
	    set ang [expr double($ang)]
	    $table insert end "{$matname} [format %5.2f $ang] [format %5.3f $t] \
		    $numlayers"
	} else {  
	    set t [expr double($t)]
	    $table insert end "{$matname} undef [format %5.3f $t] \
		    $numlayers"
	}
	$table see end
    } 
    if { $lamindex != -1 } {
	$table delete $lamindex
	if { $useangle == 1 } {
	    set t [expr double($t)]
	    set ang [expr double($ang)]
	    $table insert $lamindex "{$matname} [format %5.2f $ang] [format %5.3f $t] \
		    $numlayers"
		        
	} else {  
	    set t [expr double($t)]
	    $table insert $lamindex "{$matname} undef [format %5.3f $t] \
		    $numlayers"
		                    
	}
	$table see $lamindex
	set lamindex -1
	set t ""        
	set ang ""        
	set matname ""        
	set numlayers 1
	eval [NasComposite::refresh $can ]
	focus $entry
	grid remove $NasComposite::lammodify
	grid remove $NasComposite::lamcancel
	grid $NasComposite::lamadd
	grid $NasComposite::lamclear
    }
    set t ""        
    set ang ""        
    set matname ""        
    set numlayers 1
    eval [NasComposite::refresh $can ]
    focus $entry
}                
##############################################################
#       Edit a row into tabellist of laminate                #
##############################################################
proc NasComposite::lamedit { table } {
 variable matname          
 variable t         
 variable ang         
 variable numlayers         
 variable useangle         
 variable lamindex    
    set lamindex [$table curselection]
    if { $lamindex != "" } {
	set entry [$table get $lamindex]
	set matname [lindex $entry 0]
	set t [lindex $entry 2]
	set ang [lindex $entry 1]
	set numlayers [lindex $entry 3]
	grid $NasComposite::lammodify
	grid $NasComposite::lamcancel
	grid remove $NasComposite::lamadd
	grid remove $NasComposite::lamclear
    }
} 
##############################################################
#        Cancel edit process into tablelist laminate         #
##############################################################
proc NasComposite::lamcancel { table entry } {
 variable matname
 variable t         
 variable ang         
 variable numlayers         
 variable useangle         
 variable lamindex         
    
    $table see end
    set matname ""
    set t ""        
    set ang ""        
    set numlayers 1        
    set lamindex -1
    set useangle 1
    grid remove $NasComposite::lammodify
    grid remove $NasComposite::lamcancel 
    grid $NasComposite::lamadd
    grid $NasComposite::lamclear
    focus $entry
}
##############################################################
#              update Fiber angle entry                      #
##############################################################
proc NasComposite::update { entry bgcolor } {
  variable useangle         
	  
    if { $useangle == 1 } {
	$entry configure -bg white -state normal
    } else {
	$entry configure -bg $bgcolor -state disabled
    }
}
##############################################################
#               Clear all values into laminate page          #
##############################################################
proc NasComposite::lamclear { table } {
    variable can
    variable stressbon ""
    variable z0 ""
    variable failure None
    $table delete 0 end
    eval [NasComposite::refresh $can]
}
##############################################################
#          Draw visual description of sandwich               #
##############################################################
proc NasComposite::refresh { can } {
    variable lamlist       
    variable matlist 
    $can delete all
    set x [ winfo width $can ]
    set y [ winfo height $can ]
    set y [expr $y-16.0]
    set thick ""
    set t 0
    set matnames ""
   set ipos 0
    set aux ""
    set lamcolors ""
    set colors "moccasin green blue yellow pink gold azure orange violet \
	    brown darkgreen darkblue red cyan magenta DeepPink gray firebrick honeydew \
	    HotPink ivory IndianRed khaki lavender LawnGreen LightSalmon LightSeaGreen \
	    linen maroon MistyRose navy PaleGoldenrod peru plum purple SeaGreen SkyBlue \
	    thistle tomato turquoise wheat YellowGreen"
    foreach mat $matlist {
	lappend aux [lindex $mat 0]
	lappend aux [lindex $colors $ipos]
	set ipos [expr $ipos+1]
    }
    array set matcolors $aux
    foreach mat $lamlist {
	set numlayer [lindex $mat 3]
	set t [expr $t+[lindex $mat 2]*$numlayer]
	if { $numlayer > 0 } {
	    for { set j 0 } { $j < $numlayer } { incr j } {
		lappend thick [lindex $mat 2]
		lappend matnames [lindex $mat 0]
		lappend lamcolors $matcolors([lindex $mat 0])
	    }
	    }
    }
    set yi 8.0
    set ipos 0
    foreach ti $thick {
	lappend yi [expr [lindex $yi $ipos]+($y*$ti)/$t]
	set ipos [expr $ipos+1]
    }
   
    set x0 25.0
    set x1 [expr $x-125.0]

    set n [expr [llength $yi]-1]
    for { set i 0 } { $i < $n } {incr i 1 } {
	$can create rectangle $x0 [lindex $yi $i] $x1 [lindex $yi [expr $i+1]] \
		-fill [lindex $lamcolors $i]
    }
    if { $lamlist == "" } {
	$can delete all
    } else {
	set yleg [font metrics current -linespace]
	set xleg [expr $x1+8] 
	set ipos 0
	foreach mat $matlist {
	    $can create rectangle $xleg [expr [lindex $yi 0]+$ipos*$yleg] [expr $xleg+10] \
		    [expr [lindex $yi 0]+($ipos+1)*$yleg] -fill $matcolors([lindex $mat 0])
	    $can create text [expr $xleg+14] [expr [lindex $yi 0]+$ipos*$yleg] \
		    -text [lindex $mat 0] -justify right -anchor nw
	    set ipos [expr $ipos+1] 
	}
    }    
}


##############################################################
#       Comuniation with GiD: dump results intro GiD         #
##############################################################
proc NasComposite::dump { } {
    variable matlist
    variable lamlist
    set values ""
    set numlayer 0
    foreach layer $lamlist {
	set numlayer [expr $numlayer+[lindex $layer 3]]
    }
    lappend values $numlayer
    foreach layer $lamlist {
	set matname [lindex $layer 0]
	set numlayer [lindex $layer 3]
	foreach mat $matlist {
	    set currentmat [lindex $mat 0]
	    if { $matname == $currentmat } {
		for { set i 0 } { $i < $numlayer } { incr i } {
		    lappend values [lindex $mat 1] [lindex $mat 2] \
		            [lindex $mat 3] [lindex $mat 4] [lindex $mat 5] \
		            [lindex $mat 6] [lindex $mat 7] \
		            [lindex $layer 1] [lindex $layer 2] 
		}
		break
	    }
	}
    }
    return $values
}

#############################################################################
#Comuniation with GiD: Create a list of materials names for open window     #
#############################################################################
proc NasComposite::infonames { } {
    variable matlist
    variable lamlist
    
    set nameslist ""
    
    foreach layer $lamlist {
	set matname [lindex $layer 0]
	set numlayer [lindex $layer 3]
	lappend nameslist $matname
	lappend nameslist $numlayer
    }
    lappend nameslist end
    return $nameslist
}
##############################################################################
#   Comuniation with GiD: get the values of sandwich to show intro window    #
##############################################################################
proc NasComposite::getvalues { prop values names } {
    variable cbdatamat
    variable table
    variable lamtable
    variable can
    variable z0
    variable stressbon
    variable failure
    set z0 [lindex $prop 0]
    set stressbon [lindex $prop 1]
    set failure [lindex $prop 2] 
    set cblist ""
    set ipos1 0
    set ipos2 1
    set matname [lindex $names $ipos1]
    set numlayer [lindex $names [expr $ipos1+1]]
    $table delete 0 end
    $lamtable delete 0 end
    while { $matname != "end" } {
	set auxlam ""
	lappend auxlam $matname
	if { ![info exists auxmat($matname)] } {
	    lappend cblist "$matname"
	    set auxmat($matname) [list "$matname"]
	    set auxmat($matname) [concat $auxmat($matname) [lrange $values $ipos2 \
		    [expr $ipos2+6]]]
	    $table insert end $auxmat($matname)
	}
	set auxlam [concat $auxlam [lrange $values [expr $ipos2+7] [expr $ipos2+8]]]
	set auxlam [concat $auxlam $numlayer]
	$lamtable insert end $auxlam
	set ipos1 [expr $ipos1+2]
	set ipos2 [expr $ipos2+(9*$numlayer)]
	set matname  [lindex $names $ipos1]
	set numlayer [lindex $names [expr $ipos1+1]]
    }
    $cbdatamat configure -values $cblist
    eval [NasComposite::refresh $can]
} 
##############################################################################
#   Nastran.bas : dump the values of sandwich to nastran file in mat file    #
##############################################################################
proc NasComposite::nastran { } {
 variable matlist
 variable lamlist
 variable z0
 variable stressbon
 variable failure
    set values ""
    set numlayer 0
    foreach layer $lamlist {
	set numlayer [expr $numlayer+[lindex $layer 3]]
    }
    lappend values $numlayer $z0 $stressbon $failure
    foreach layer $lamlist {
	for { set i 1 } { $i <= [lindex $layer 3] } { incr i } {
	    lappend values [lindex $layer 0] [lindex $layer 1] [lindex $layer 2] YES
	}
    }
    foreach mat $matlist {
	lappend values [lindex $mat 0] [lindex $mat 1] \
		[lindex $mat 2] [lindex $mat 3] [lindex $mat 4] \
		[lindex $mat 5] [lindex $mat 6] [lindex $mat 7] 
    }
    return $values
}

proc NasComposite::getmatnum { input } {
    variable gidmatnum
    set gidmatnum $input
    return ""
}

##############################################################################
#   Nastran.bas : write Nastran output    #
##############################################################################

proc NasComposite::writenastran { values } {

 variable gidmatnum
    
    
    set buffer ""
    append buffer "PCOMP   " [format %8i $gidmatnum] [format %#8.3g [lindex $values 1]] \
	    "        [format %#8.1e [lindex $values 2]]"
    switch [lindex $values 3] {
	"Hill" { append buffer "    HILL" }
	"Hoffman" { append buffer "    HOFF" }
	"Stress" { append buffer "  STRESS" }
	"Strain" { append buffer "  STRAIN" }
	"None" { append buffer "        " }
    }
    append buffer "     0.0                +COMP" [format %3i $gidmatnum]\n
    append buffer +COMP [format %3i $gidmatnum]
    set numlayer [lindex $values 0]
    set id 1
    set line 1
    for { set i 4 } { $i <= [expr 4*$numlayer] } { incr i 4 } {
	if { ! [info exists matid([lindex $values $i])] } {
	    set matid([lindex $values $i]) [expr $gidmatnum+100+$id]
	    set id [incr id] 
	}
	if { $line == 1 } {
	    append buffer [format %8i $matid([lindex $values $i])] \
		    [format %#8.3g [lindex $values [expr $i+2]]]\
		    [format %#8.3g [lindex $values [expr $i+1]]]\
		    "     [lindex $values [expr $i+3]]"
	    set cntrline 1
	}
	if { $line == 2 } {
	    append buffer [format %8i $matid([lindex $values $i])] \
		    [format %#8.3g [lindex $values [expr $i+2]]]\
		    [format %#8.3g [lindex $values [expr $i+1]]]\
		    "     [lindex $values [expr $i+3]]" "+COM" \
		    [format %4i $matid([lindex $values $i])]\n
	    append buffer +COM [format %4i $matid([lindex $values $i])]
	    set cntrline 2
	}
	
	if { $cntrline == 1 } {
	    set line 2 
	} else {
	    set line 1
	}
    }
    append buffer \n
    set ipos $i
    set matname [lindex $values $ipos]
    while { $matname != "" } {
	append buffer "MAT8    " [format %8i $matid($matname)] \
	    [format %#8.3g [lindex $values [expr $ipos+1]]]\
	    [format %#8.3g [lindex $values [expr $ipos+2]]] \
	    [format %#8.3g [lindex $values [expr $ipos+3]]] \
	    [format %#8.3g [lindex $values [expr $ipos+4]]] \
	    [format %#8.3g [lindex $values [expr $ipos+5]]] \
	    [format %#8.3g [lindex $values [expr $ipos+6]]] \
	    [format %#8.3g [lindex $values [expr $ipos+7]]] \n 
	set ipos [expr $ipos+8]
	set matname [lindex $values $ipos]
	}
    return $buffer
}
    
proc NasComposite::errorcntrl { values window} {
    set message ""
    if {[llength $values] != [lindex $values 0]  } {
	set message "Some entries are blank.\nPlease check for errors\n" 
    }
    set values [string range $values 1 end]
    foreach elem $values {
	if { ! [string is double -strict $elem ] } {
	    append message "$elem is not a valid input \n"
	}
    }
    if  { $message != "" } {
	WarnWin $message $window
	#tk_messageBox -message $message -type ok        
	return 1
    }
    return 0
}


##############################################################################
#   
# 
#                              Pop up menu of laminate table    #
# 
# 
# #############################################################################

proc NasComposite::popupmenu { parent x y } {
    variable lamtable 
    catch { destroy $parent.menu }
    set menu [menu $parent.menu -type normal ]
    $menu add command -label Paste -command NasComposite::poppaste
    $menu add command -label Sym+Paste -command NasComposite::popsympaste
    $menu add command -label Delete -command "NasComposite::lamdelete $lamtable {}"
    tk_popup $menu $x $y
   
} 

proc NasComposite::poppaste { } {
    variable lamtable 
    variable can
    set indexs [$lamtable curselection ]
    foreach index $indexs {
	$lamtable insert end [$lamtable get $index]
    }
    NasComposite::refresh $can
}
proc NasComposite::popsympaste { } {
    variable lamtable 
    variable can
    set indexs ""
    for { set i [expr [llength [$lamtable curselection ]]-1] } { $i >=0 } { incr i -1} {
	lappend indexs [ lindex [$lamtable curselection ] $i]
    }  
    foreach index $indexs {
	$lamtable insert end [$lamtable get $index]
    }
    NasComposite::refresh $can
}
